using System;
using System.Collections.Generic;
using System.Text;
using Components.Agenda.GUI;

namespace Components.Agenda.GUI.EventArgsObj
{
    /// <summary>
    /// Informations sur une demande de rendez-vous
    /// </summary>
    public class MeetingEventArgs : EventArgs
    {
        #region Variables
        /// <summary>
        /// Informations sur le rendez-vous selectionn
        /// </summary>
        protected MeetingInfo vMeetingInfo;
        #endregion

        #region Constructeurs
        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_mi">Informations sur le rendez-vous demand</param>
        public MeetingEventArgs(MeetingInfo _mi) { vMeetingInfo = _mi; }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne la date de dbut du rendez-vous
        /// </summary>
        public DateTime StartingHour { get { return vMeetingInfo.Start; } }

        /// <summary>
        /// Retourne la date de fin du rendez-vous
        /// </summary>
        public DateTime EndingHour { get { return vMeetingInfo.End; } }

        /// <summary>
        /// Retourne toutes les informations sur le rendez-vous
        /// </summary>
        public MeetingInfo MeetingInfo { get { return vMeetingInfo; } }
        #endregion
    }
}
