using System;
using System.Collections.Generic;
using System.Text;
using Components.Agenda.GUI;

namespace Components.Agenda.GUI.EventArgsObj
{
    /// <summary>
    /// Informations sur un vnement de demande de modification ou de suppression de rendez-vous
    /// </summary>
    public class MeetingModificationEventArgs : MeetingEventArgs
    {
        #region Variables
        private int vIDMeeting;
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_Mi">Information sur le rendez-vous</param>
        /// <param name="_IDMeeting">Identifiant du rendez-vous</param>
        public MeetingModificationEventArgs(MeetingInfo _Mi, int _IDMeeting)
            : base(_Mi)
        {
            vIDMeeting = _IDMeeting;
        }
        #endregion

        #region Accesseur
        /// <summary>
        /// Retourne l'identifiant du rendez-vous selecitoner pour la suppression ou la modification
        /// </summary>
        public int IDMeeting
        {
            get { return vIDMeeting; }
        }
        #endregion
    }
}
