using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Components.Agenda.Management;
using Components.Agenda.Management.StructsEnums;

namespace Components.Agenda.Frame
{
    /// <summary>
    /// Fentre standard pour la selection d'une heure
    /// </summary>
    public partial class fr_HourSelector : Form
    {
        #region Constructeur
        /// <summary>
        /// Constructeur par dfaut
        /// </summary>
        public fr_HourSelector()
        {
            InitializeComponent();
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Transforme l'heure slectionne en texte 00h00
        /// </summary>
        public string HourToText(DateTime _dt)
        {
            string Hour = _dt.Hour.ToString();
            if (_dt.Hour < 10)
                Hour = "0" + Hour;

            string Minute = _dt.Minute.ToString();

            if (_dt.Minute < 10)
                Minute = "0" + Minute;

            return Hour + "h" + Minute;
        }
        /// <summary>
        /// Gives the selected hour in string
        /// </summary>
        /// <returns></returns>
        public override string ToString() { return SelectedHour.ToShortTimeString(); }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise l'heure selectionne dans le composant
        /// </summary>
        public DateTime SelectedHour
        {
            get { return hs_Selection.SelectedHour; }
            set { hs_Selection.SelectedHour = value; }
        }
        /// <summary>
        /// Indicates how the minutes will be selected
        /// </summary>
        public MinutesSelection MinutesSelection
        {
            get { return hs_Selection.MinutesSelection; }
            set { hs_Selection.MinutesSelection = value; }
        }
        #endregion

        #region Events
        /// <summary>
        /// Evnement sur un clique sur OK
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_OK(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.OK;
            this.Close();
        }
        #endregion
    }
}