using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Components.Agenda.Management
{
    /// <summary>
    /// Structure de base pour le dessin d'une case du MonthAgenda ou du DayAgenda
    /// </summary>
    public class RectangleInfo
    {
        /// <summary>
        /// Constructeur
        /// </summary>
        public RectangleInfo()
        {
            BackColor = Color.White;
            Rectangle = new Rectangle();
            TextFont = new Font("Times new Roman", 12);
            TextColor = Color.Black;
            BorderPen = new Pen(Color.Silver);
            Text = "";
        }
        /// <summary>
        /// Taille de la case
        /// </summary>
        public Rectangle Rectangle;
        /// <summary>
        /// Texte  afficher dans la case
        /// </summary>
        public string Text;
        /// <summary>
        /// Police du texte
        /// </summary>
        public Font TextFont;
        /// <summary>
        /// Couleur du texte
        /// </summary>
        public Color TextColor;
        /// <summary>
        /// Couleur de la case
        /// </summary>
        public Color BackColor;
        /// <summary>
        /// Couleur de contour du rectangle
        /// </summary>
        public Pen BorderPen;
    }
}
