using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Design;
using System.Windows.Forms.Design;

namespace Components.TypeEditors.GUI
{

    /// <summary>
    /// Editeur pour la selection d'un texte long
    /// </summary>
    public class UILongTextEditor : UITypeEditor
    {
        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;//base.GetEditStyle(context);
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override bool GetPaintValueSupported(System.ComponentModel.ITypeDescriptorContext context)
        {
            return false;
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context,
            IServiceProvider provider, object value)
        {
            if (provider != null)
            {
                IWindowsFormsEditorService editor =
                    (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

                if (editor != null)
                {
                    fr_LongTextEditor fr = new fr_LongTextEditor();
                    fr.IsFontSelectable = false;
                    fr.SelectedText = (string)value;
                    DialogResult dr = fr.ShowDialog();
                    if (dr == DialogResult.OK)
                        value = (object)fr.SelectedText;
                }
            }
            return value;
        }
    }
}
