using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;
using System.Windows.Forms.Design;
using System.Windows.Forms;
using Components.Agenda.Frame;
using Components.Agenda.Management;
using Components.Agenda.Management.StructsEnums;

namespace Components.TypeEditors
{    
    /// <summary>
    /// Type editor for the selection of an hour
    /// </summary>
    public class UIHourEditor : UITypeEditor
    {
        #region Variables
        /// <summary>
        /// HourSelector frame
        /// </summary>
        private fr_HourSelector ds = new fr_HourSelector();
        #endregion

        #region Mthodes
        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;//base.GetEditStyle(context);
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override bool GetPaintValueSupported(System.ComponentModel.ITypeDescriptorContext context)
        {
            return false;
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context,
            IServiceProvider provider, object value)
        {
            if (provider != null)
            {
                IWindowsFormsEditorService editor =
                    (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

                if (editor != null)
                {
                    #region Affichage du menu de choix  
                    //TODO: mettre un menu de selection
                    ds.MinutesSelection = MinutesSelection.HalfAnHour;
                    DialogResult dr = ds.ShowDialog();

                    if (dr == DialogResult.OK)
                    {
                        value = (object)ds.SelectedHour.ToString();                        
                    }
                    #endregion
                }
            }
            return value;
        }

        /// <summary>
        /// Surcharge la mthode de convertion en string
        /// </summary>
        /// <returns>Le nom de mdecin sekectionn</returns>
        public override string ToString()
        {
            return this.ds.SelectedHour.ToShortTimeString();
        }
        #endregion
    }
}
