using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;
using System.Windows.Forms.Design;
using System.Windows.Forms;

namespace Components.TypeEditors
{
    /// <summary>
    /// Editeur pour la selction d'un path
    /// </summary>
    public class UIPathEditor : UITypeEditor
    {
        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;//base.GetEditStyle(context);
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override bool GetPaintValueSupported(System.ComponentModel.ITypeDescriptorContext context)
        {
            return false;
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context,
            IServiceProvider provider, object value)
        {
            if (provider != null)
            {
                IWindowsFormsEditorService editor =
                    (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

                if (editor != null)
                {
                    OpenFileDialog ofd = new OpenFileDialog();
                    DialogResult dr = ofd.ShowDialog();
                    if(dr == DialogResult.OK)
                    value = (object)ofd.FileName;
                }
            }
            return value;
        }
    }
}
