using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Components.Webcam
{
    /// <summary>
    /// Classe de gestion de la webcam
    /// </summary>
    public class WebcamEventArgs : EventArgs
    {
        #region Variables
        /// <summary>
        /// Image de la webcam
        /// </summary>
        private Image vWebCamImage;

        /// <summary>
        /// Frame buffer
        /// </summary>
        private ulong vFrameBuffer = 0;
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur d'initialisation
        /// </summary>
        /// <param name="_FrameBuffer">Frame buffer</param>
        /// <param name="_WebCamImage">Image de la webcam</param>
        public WebcamEventArgs(Image _WebCamImage, ulong _FrameBuffer)
        {
            vWebCamImage = _WebCamImage;
            vFrameBuffer = _FrameBuffer;
        }

        /// <summary>
        /// Constructeur par dfaut
        /// </summary>
        public WebcamEventArgs() { }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne l'image de la webcam
        /// </summary>
        public Image WebCamImage
        {
            internal set { vWebCamImage = value; }
            get { return vWebCamImage; }
        }

        /// <summary>
        /// Retourne le frame buffer
        /// </summary>
        public ulong FrameBuffer
        {
            internal set { vFrameBuffer = value; }
            get { return vFrameBuffer; }
        }
        #endregion
    }
}
