﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using PhoenixAgenda.GUI;
using Utils.Log;
using Microsoft.Win32;
using Utils.Misc;
using PhoenixDLL.Class;
using Components.SplashBar;
using System.IO;
using System.Data.OleDb;
using PhoenixDLL.GUI;

namespace PhoenixAgenda
{
    static class Program
    {
        /// <summary>
        /// Point d'entrée principal de l'application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            try
            {                
                SplashBar.ShowSplash(4, 0, 1);
                fr_Main fr = new fr_Main();

                SplashBar.PerformStep();
                MeetingSet ms = new MeetingSet();
                SplashBar.PerformStep();
                ms.Path = Options.GetInstance().Path;
                SplashBar.PerformStep();
                ms.Fill();
                SplashBar.PerformStep();
                SplashBar.CloseSplash();


                fr.MeetingSet = ms;
                Application.Run(fr);
            }
            #region Exception
            catch (FileNotFoundException)
            {
                SplashBar.CloseSplash();
                MessageBox.Show("Veuillez indiquer dans les options où se trouve la base de données.\n"
                    + "Indiquez les bonnes options et redémarrez l'application",
                    "Attention", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                fr_Options fr = new fr_Options();
                fr.StartPosition = FormStartPosition.CenterScreen;
                fr.ShowDialog();
                fr.Dispose();
            }
            catch (OleDbException ex)
            {
                SplashBar.CloseSplash();
                MessageBox.Show("Une erreur au niveau de la base de données est survenue.\n"
                    + "Indiquez les bonnes options et redémarrez l'application \n(" + ex.Message + ")",
                    "Attention", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                fr_Options fr = new fr_Options();
                fr.StartPosition = FormStartPosition.CenterScreen;
                fr.ShowDialog();
                fr.Dispose();
            }
            catch (Exception ex)
            {
                SplashBar.CloseSplash();
                Components.ErrorCatching.fr_ErrorCatching fr = new Components.ErrorCatching.fr_ErrorCatching();
                Options opt = Options.GetInstance();
                fr.SMTPServer = opt.SMTPServer;
                fr.SMTPPort = opt.SMTPPort;
                fr.SMTPPassword = opt.SMTPPassword;
                fr.IsMailable = false;

                fr.ExceptionToDisplay = ex;
                fr.Remark = "Une erreur non traitée est survenue. Voulez-vous envoyer ces informations au développeur?";
                fr.ShowDialog();
                fr.Dispose();
            }            
            #endregion
        }
    }
}