using System;
using System.Collections.Generic;
using System.Text;

namespace PhoenixDLL.Class.Exceptions
{
    /// <summary>
    /// Reprsente un traitement impossible  cause d'une selection non faite
    /// </summary>
    public class NotSelectedException : Exception
    {
        /// <summary>
        /// Constructeur
        /// </summary>
        public NotSelectedException() : base("Veuillez selectionner une option") { }

        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_Message">Message d'erreur de l'exception</param>
        public NotSelectedException(string _Message) : base(_Message) { }
    }

    /// <summary>
    /// Lorsque on tente d'imprimer une liste de prescription et que l'une de celles-co contient
    /// une remarque qui tient en plus d'une page, cette exception est lance
    /// </summary>
    public class OutOfPageException : Exception
    {
        /// <summary>
        /// Constructeur
        /// </summary>
        public OutOfPageException()
            : base("Au moins une remarque de la liste de prescription est trop longue et ne peut tre"
            + " imprime!") { }

        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_Message">Message d'erreur de l'exception</param>
        public OutOfPageException(string _Message) : base(_Message) { }
    }

    #region Registry
    /// <summary>
    /// Classe de gestion d'erreur dans les informations  propos de la suite Phoenix dans la base de registre
    /// Cette exception doit tre lance quand il y a des incohrence entre l'applcation et le contenu de la base de registre
    /// </summary>
    public class RegistrySetupException : Exception
    {
        /// <summary>
        /// Constructeur
        /// </summary>
        public RegistrySetupException()
            : base("Les informations de l'application et celles enregistre sont diffrente. Peut tre utilisez-vous plusieurs"
            + " version de la suite Phoenix...") { }

        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_Message">Message d'erreur personalis</param>
        public RegistrySetupException(string _Message) : base(_Message) { }
    }
    #endregion
}
