using System;
using System.Collections.Generic;
using System.Text;

namespace PhoenixDLL.Class
{
    /// <summary>
    /// Data used during an instance for inter object communication
    /// </summary>
    public class InstanceInterData
    {
        #region Variables
        /// <summary>
        /// Ref on this object
        /// </summary>
        private static readonly InstanceInterData refInstanceData = new InstanceInterData();

        #region Stata
        /// <summary>
        /// Indicates if a patient modification needs to ask again a reboot of Phoenix Suite
        /// </summary>
        private bool vStataAskReboot = true;
        /// <summary>
        /// Indicates if a patient modification needs to ask to ask again a reboot of Phoenix Suite
        /// </summary>
        private bool vStataAskAskReboot = true;
        #endregion
        #endregion

        #region Constructor
        /// <summary>
        /// Constructor
        /// </summary>
        protected InstanceInterData() { }
        /// <summary>
        /// Gets the instance of this object
        /// </summary>
        public static InstanceInterData Instance { get { return refInstanceData; } }
        #endregion

        #region Properties
        /// <summary>
        /// Gets or sets a value which indicates if there is a prompt to ask a reboot
        /// </summary>
        public bool Stata_AskReboot { get { return vStataAskReboot; } set { vStataAskReboot = value; } }
        /// <summary>
        /// Gets or sets a value which indicates if there is a prompt to ask to ask a reboot
        /// </summary>
        public bool Stata_AskAskReboot { get { return vStataAskAskReboot; } set { vStataAskAskReboot = value; } }
        #endregion
    }
}
