using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace PhoenixDLL.Class.Interface
{
    /// <summary>
    /// Interface qui implmente les mthodes de bases pour un manager de table
    /// </summary>
    /// <typeparam name="Type"></typeparam>
    interface IManager<Type>
    {
        /// <summary>
        /// Fait une mise  jour d'un honoraire
        /// </summary>
        void Update();
        /// <summary>
        /// Ajoute un honoraire.
        /// </summary>
        void Add();
        /// <summary>
        /// Supprime l'honoraire
        /// </summary>
        void Delete();
        /// <summary>
        /// Rempli le manager sur base d'un identifiant
        /// </summary>        
        Type Create();
        /// <summary>
        /// Indicates if the manager is empty
        /// </summary>
        [Browsable(false)]
        bool Empty { get;}
    }
    /// <summary>
    /// Indicates values
    /// </summary>
    public struct Value
    {
        /// <summary>
        /// Indicates a numeric value which is -999 (Normally it is not an ID value)
        /// </summary>
        public const int NULL = -999;
    }
}
