using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;
using PhoenixDLL.Class.Managers;
using System.Windows.Forms.Design;
using PhoenixDLL.GUI.Seekers;
using System.Windows.Forms;

namespace PhoenixDLL.Editors
{
    /// <summary>
    /// Editeur de rputation
    /// </summary>
    class UIReputationEditor : UITypeEditor
    {
        #region Variables
        /// <summary>
        /// Informations sur la rputation
        /// </summary>
        private ReputationManager vReputation = new ReputationManager();
        #endregion

        #region Mthodes
        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;//base.GetEditStyle(context);
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override bool GetPaintValueSupported(System.ComponentModel.ITypeDescriptorContext context)
        {
            return false;
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context,
            IServiceProvider provider, object value)
        {
            if (provider != null)
            {
                IWindowsFormsEditorService editor =
                    (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

                if (editor != null)
                {
                    #region Affichage du menu de choix                    
                    fr_ReputationSeeker ds = new fr_ReputationSeeker();
                    DialogResult dr = ds.ShowDialog();

                    if (dr == DialogResult.OK)
                    {
                        value = (object)ds.SelectedItem;
                        vReputation = ds.SelectedItem;
                    }
                    #endregion
                }
            }
            return value;
        }
        #endregion

        #region Overriden
        /// <summary>
        /// Donne le nom de la rputation
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return vReputation.Label;
        }
        #endregion
    }
}
