using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PhoenixDLL.GUI.Managers.Root
{
    /// <summary>
    /// Classe de base pour une hirarche de manager
    /// </summary>    
    public partial class fr_RootManager : Form
    {
        #region Variables
        /// <summary>
        /// Utilisation de la fentre
        /// </summary>
        protected Use vUse = Use.Update;
        #endregion

        #region Constructeurs
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_RootManager() { InitializeComponent(); }
        #endregion

        #region Event
        /// <summary>
        /// Clique sur OK
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_OK(object sender, EventArgs e)
        {
            ProcessOK();
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Traitement sur un clique sur OK
        /// </summary>
        protected virtual void ProcessOK()
        {
            MessageBox.Show("You pressed on OK", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
            base.DialogResult = DialogResult.OK;
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise l'utilisation du gestionnaire
        /// </summary>
        public Use Use
        {
            get { return vUse; }
            set
            {
                vUse = value;
                if (value == Use.Delete)
                    pg_PropertyGrid.Enabled = false;
                else
                    pg_PropertyGrid.Enabled = true;
            }
        }
        #endregion
    }
}