using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class.Managers;
using PhoenixDLL.GUI.Managers.Root;
using Utils.Log;

namespace PhoenixDLL.GUI.Managers
{
    /// <summary>
    /// Gestionnaire graphique de mdecins
    /// </summary>
    public partial class fr_DoctorManager : fr_RootManager
    {
        #region Variables
        /// <summary>
        /// Gestionnaire de mdecin
        /// </summary>
        private DoctorManager vDoctorManager = new DoctorManager();
        #endregion

        #region Constructeurs
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_DoctorManager()
        {
            InitializeComponent();
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Traitement sur un clique sur OK
        /// </summary>
        protected override void ProcessOK()
        {
            try
            {
                switch (vUse)
                {
                    case Use.Update:
                        vDoctorManager.Update();
                        base.DialogResult = DialogResult.OK;
                        break;
                    case Use.Delete:
                        vDoctorManager.Delete();
                        base.DialogResult = DialogResult.OK;
                        break;
                    case Use.Add:
                        vDoctorManager.Add();
                        base.DialogResult = DialogResult.OK;
                        break;
                }
            }
            catch (Exception ex)
            {
                #region Deleting error
                if (vUse == Use.Delete)
                {
                    MessageBox.Show("Il est impossible d'effacer cette entre...\r\n("
                        + ex.Message + ")", "Asterisk", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                #endregion
                else
                {
                    MessageBox.Show("Une erreur est survenue (" + ex.Message + ")",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    Log.Instance.Write(ex.Message, "fr_ReputationManager.ProcessOK()", LogType.Erreur);
                }
            }
            finally { this.Close(); }
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise la manager de mdecin
        /// </summary>
        public DoctorManager Manager
        {
            get { return vDoctorManager; }
            set
            {
                vDoctorManager = value;
                base.pg_PropertyGrid.SelectedObject = vDoctorManager;
            }
        }
        #endregion
    }
}

