using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class.Managers;
using Utils.Log;
using PhoenixDLL.GUI.Managers.Root;

namespace PhoenixDLL.GUI.Managers
{
    /// <summary>
    /// Gestionnaire d'honoraire
    /// </summary>
    public partial class fr_MutuelleManager : fr_RootManager
    {
        #region Variables
        /// <summary>
        /// Informations sur l'honoraire
        /// </summary>
        private MutuelleManager vMutuelleManager = new MutuelleManager();
        #endregion

        #region Constructeurs
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_MutuelleManager()
        {
            InitializeComponent();
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Traitement sur un clique sur OK
        /// </summary>
        protected override void ProcessOK()
        {
            try
            {
                switch (vUse)
                {
                    case Use.Update:
                        vMutuelleManager.Update();
                        base.DialogResult = DialogResult.OK;
                        break;
                    case Use.Delete:
                        vMutuelleManager.Delete();
                        base.DialogResult = DialogResult.OK;
                        break;
                    case Use.Add:
                        vMutuelleManager.Add();
                        base.DialogResult = DialogResult.OK;
                        break;
                }
            }
            catch (Exception ex)
            {
                #region Deleting error
                if (vUse == Use.Delete)
                {
                    MessageBox.Show("Il est impossible d'effacer cette entre...\r\n("
                        + ex.Message + ")", "Asterisk", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                #endregion
                else
                {
                    MessageBox.Show("Une erreur est survenue (" + ex.Message + ")",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    Log.Instance.Write(ex.Message, "fr_ReputationManager.ProcessOK()", LogType.Erreur);
                }
            }
            finally { this.Close(); }
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise les informations sur l'honoraire
        /// </summary>
        public MutuelleManager Manager
        {
            get { return vMutuelleManager; }
            set
            {
                vMutuelleManager = value;
                pg_PropertyGrid.SelectedObject = Manager;
            }
        }
        #endregion
    }
}

