using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.GUI.Managers.Root;
using PhoenixDLL.Class.Managers;
using Utils.Log;

namespace PhoenixDLL.GUI.Managers
{
    /// <summary>
    /// Gestionnaire de prescriptions
    /// </summary>
    public partial class fr_PrescriptionManager : fr_RootManager
    {
        #region Variables
        private PrescriptionManager vPrescriptionManager = new PrescriptionManager();
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_PrescriptionManager()
        {
            InitializeComponent();
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Traitement du clique sur OK
        /// </summary>
        protected override void ProcessOK()
        {            
            try
            {
                switch (base.Use)
                {
                    case Use.Add:
                        vPrescriptionManager.Add();
                        base.DialogResult = DialogResult.OK;
                        break;
                    case Use.Update:
                        vPrescriptionManager.Update();
                        break;
                    case Use.Delete:
                        DialogResult dr = MessageBox.Show("Etes-vous sur de vouloir supprimer cette prescription?",
                            "Question", MessageBoxButtons.YesNo, MessageBoxIcon.Asterisk);
                        if (dr == DialogResult.Yes)
                        {
                            vPrescriptionManager.Delete();
                            base.DialogResult = DialogResult.OK;
                        }
                        else
                            base.DialogResult = DialogResult.Cancel;
                        break;
                }
            }
            catch (Exception ex)
            {
                #region Deleting error
                if (vUse == Use.Delete)
                {
                    MessageBox.Show("Il est impossible d'effacer cette entre...\r\n("
                        + ex.Message + ")", "Asterisk", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                #endregion
                else
                {
                    MessageBox.Show("Une erreur est survenue (" + ex.Message + ")",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    Log.Instance.Write(ex.Message, "fr_PrescriptionManagerProcessOK()", LogType.Erreur);
                }
            }
            finally { this.Close(); }
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise le manager de mdicaments
        /// </summary>
        public PrescriptionManager Manager
        {
            get { return vPrescriptionManager; }
            set
            {
                vPrescriptionManager = value;
                base.pg_PropertyGrid.SelectedObject = vPrescriptionManager;
            }
        }
        #endregion
    }
}

