using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class.Managers;
using PhoenixDLL.GUI.Managers.Root;
using Utils.Log;

namespace PhoenixDLL.GUI.Managers
{
    /// <summary>
    /// Gestionnaire graphique de rputation
    /// </summary>
    public partial class fr_ReputationManager : fr_RootManager
    {
        #region Variables
        /// <summary>
        /// Gestionnaire de Rputations
        /// </summary>
        private ReputationManager vReputationManager = new ReputationManager();
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_ReputationManager()
        {
            InitializeComponent();
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Traitement d'un clique sur OK
        /// </summary>
        protected override void ProcessOK()
        {
            try
            {
                switch (vUse)
                {
                    case Use.Add:
                        vReputationManager.Add();
                        break;
                    case Use.Delete:
                        vReputationManager.Delete();
                        break;
                    case Use.Update:
                        vReputationManager.Update();
                        break;
                }
            }
            catch (Exception ex)
            {
                #region Deleting error
                if (vUse == Use.Delete)
                {
                    MessageBox.Show("Il est impossible d'effacer cette entre...\r\n("
                        + ex.Message + ")", "Asterisk", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                #endregion
                else
                {
                    MessageBox.Show("Une erreur est survenue (" + ex.Message + ")",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    Log.Instance.Write(ex.Message, "fr_ReputationManager.ProcessOK()", LogType.Erreur);
                }
            }
            finally { this.Close(); }
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise les informations sur la rputation
        /// </summary>
        public ReputationManager Manager
        {
            get { return vReputationManager; }
            set
            {
                vReputationManager = value;
                pg_PropertyGrid.SelectedObject = Manager;
            }
        }
        #endregion
    }
}

