using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PhoenixDLL.GUI.Seekers.Root
{
    /// <summary>
    /// Base d'une boite de recherche ComboBox
    /// </summary>
    public partial class fr_RootComboBoxSeeker : Form
    {
        #region Variables
        /// <summary>
        /// Rsultat de la boite de dialogue
        /// </summary>
        protected DialogResult vDialogResult = DialogResult.Cancel;
        #endregion

        #region Constructeurs
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_RootComboBoxSeeker()
        {
            InitializeComponent();
        }
        #endregion

        #region Events
        /// <summary>
        /// Clique sur annuler
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_Cancel(object sender, EventArgs e) { PerformCancel(); }
        /// <summary>
        /// Clique sur ajouter
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_Add(object sender, EventArgs e) { PerformAdd(); }
        /// <summary>
        /// Clique sur slection
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_Select(object sender, EventArgs e) 
        {
            if (cb_Reput.Items.Count < 1)
            {
                MessageBox.Show("Il n'y a aucun lment  slectionner!", 
                    "Information", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }            
            PerformSelect(); 
        }       
        /// <summary>
        /// Chargement de la fentre
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_FrameLoad(object sender, EventArgs e) { PerformLoad(); }
        #endregion        

        #region Mthodes
        /// <summary>
        /// Excute une annulation
        /// </summary>
        protected virtual void PerformCancel()
        {
            base.DialogResult = vDialogResult;
            this.Close();
        }
        /// <summary>
        /// Excute un ajout
        /// </summary>
        protected virtual void PerformAdd()
        {
            //base.DialogResult = DialogResult.OK;
            this.vDialogResult = DialogResult.OK;            
            PerformFillComboBox();
            //this.Close();
        }
        /// <summary>
        /// Excute une slection
        /// </summary>
        protected virtual void PerformSelect()
        {
            base.DialogResult = DialogResult.OK;
            this.Close();
        }
        /// <summary>
        /// Fait un chargement de la ComboBox
        /// </summary>
        private void PerformLoad() { PerformFillComboBox(); }
        /// <summary>
        /// Mthode de remplissage de la ComboBox
        /// </summary>
        protected virtual void PerformFillComboBox() { }
        #endregion 

        #region Properties
        /// <summary>
        /// Retourne le rsultat de la boite de dialogue
        /// </summary>
        public new DialogResult DialogResult { get { return vDialogResult; } }
        #endregion
    }
}