using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Utils.DataBase;
using PhoenixDLL.Class.Managers;
using System.Threading;
using System.Data.OleDb;
using Utils.Log;
using PhoenixDLL.Class;
using PhoenixDLL.GUI.Seekers.Root;
using PhoenixDLL.GUI.Managers;
using PhoenixDLL.Class.Interface;

namespace PhoenixDLL.GUI.Seekers
{
    /// <summary>
    /// Chercheur de mdecins
    /// </summary>
    public partial class fr_DoctorSeeker : fr_RootSeeker
    {
        #region Variables
        /// <summary>
        /// Gestionnaire de Mdecins
        /// </summary>
        private DoctorManager vDoctorManager = new DoctorManager();
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_DoctorSeeker()
        {
            InitializeComponent();
            base.tsMenu_Del.Visible = true;
        }
        #endregion

        #region Event
        /// <summary>
        /// Evnement sur changement de texte
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_TextChanged(object sender, EventArgs e) { RefreshDGV(); }
        /// <summary>
        /// Evnement sur changement de RadioButton
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_CheckedChanged(object sender, EventArgs e)
        {
            //if (tb_Nom.Text != "" || tb_Nom.Text != "")
            {
                this.tsPB_ProgressBar.Style = ProgressBarStyle.Marquee;

                //Cration et lancement du thread
                if (th_Seeker != null && !th_Seeker.IsAlive)
                {
                    ThreadDoctor th = new ThreadDoctor(tb_Nom.Text, tb_Prenom.Text, rb_Medic.Checked,
                        rb_Homeopath.Checked, this);
                    th_Seeker = new Thread(new ThreadStart(th.ProcessOnName));
                    th_Seeker.Name = "DataBase Thread";
                    th_Seeker.Start();
                }
                else
                {
                    if (th_Seeker != null)
                        th_Seeker.Abort();

                    ThreadDoctor th = new ThreadDoctor(tb_Nom.Text, tb_Prenom.Text, rb_Medic.Checked,
                        rb_Homeopath.Checked, this);
                    th_Seeker = new Thread(new ThreadStart(th.ProcessOnName));
                    th_Seeker.Name = "DataBase Thread";
                    th_Seeker.Start();
                }
            }

        }        
        /// <summary>
        /// Clique sur le bouton de "Sans mdecin"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_NoneDoctor(object sender, EventArgs e)
        {
            this.SelectedItem.ID = Value.NULL;
            DialogResult = DialogResult.OK;
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Eccute le traitement sur double clique sur le DataGridView
        /// </summary>
        protected override void ExecuteDoubleClick()
        {
            if (dgv_Results.SelectedRows.Count != 0)
            {
                if (!dgv_Results.SelectedRows[0].Cells["Adresse"].Value.Equals(DBNull.Value))
                    vDoctorManager.Adresse = (string)dgv_Results.SelectedRows[0].Cells["Adresse"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["CodePostal"].Value.Equals(DBNull.Value))
                    vDoctorManager.CodePostal = (string)dgv_Results.SelectedRows[0].Cells["CodePostal"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["Fax"].Value.Equals(DBNull.Value))
                    vDoctorManager.Fax = (string)dgv_Results.SelectedRows[0].Cells["Fax"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["id_Medecin"].Value.Equals(DBNull.Value))
                    vDoctorManager.ID = (int)dgv_Results.SelectedRows[0].Cells["id_Medecin"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["Homeopathe"].Value.Equals(DBNull.Value))
                    vDoctorManager.IsHomeo = (bool)dgv_Results.SelectedRows[0].Cells["Homeopathe"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["MedecinTraitant"].Value.Equals(DBNull.Value))
                    vDoctorManager.IsMedecin = (bool)dgv_Results.SelectedRows[0].Cells["MedecinTraitant"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["Nom"].Value.Equals(DBNull.Value))
                    vDoctorManager.Nom = (string)dgv_Results.SelectedRows[0].Cells["Nom"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["Prenom"].Value.Equals(DBNull.Value))
                    vDoctorManager.Prenom = (string)dgv_Results.SelectedRows[0].Cells["Prenom"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["Telephone"].Value.Equals(DBNull.Value))
                    vDoctorManager.Telephone = (string)dgv_Results.SelectedRows[0].Cells["Telephone"].Value;

                if (!dgv_Results.SelectedRows[0].Cells["Ville"].Value.Equals(DBNull.Value))
                    vDoctorManager.Ville = (string)dgv_Results.SelectedRows[0].Cells["Ville"].Value;

                base.DialogResult = DialogResult.OK;
                this.Close();
            }

        }
        /// <summary>
        /// Fait un ajout de mdecin
        /// </summary>
        protected override void ExecuteAdd()
        {
            fr_DoctorManager dm = new fr_DoctorManager();
            dm.Use = Use.Add;
            dm.Manager = new DoctorManager();
            dm.Size = new Size(dm.Size.Width, 400);
            DialogResult dr = dm.ShowDialog();
            if (dr != DialogResult.OK) return;
            RefreshDGV();
        }
        /// <summary>
        /// Fait une suppression de mdecin
        /// </summary>
        protected override void ExecuteDel()
        {
            fr_DoctorManager dm = new fr_DoctorManager();
            dm.Use = Use.Delete;
            dm.Manager = DoctorManager.Create((int)dgv_Results.SelectedRows[0].Cells["id_Medecin"].Value);
            dm.Size = new Size(dm.Size.Width, 400);
            DialogResult dr = dm.ShowDialog();
            if (dr != DialogResult.OK) return;
            RefreshDGV();
        }
        /// <summary>
        /// Refreshes the DataGridView
        /// </summary>
        protected override void RefreshDGV()
        {
            this.tsPB_ProgressBar.Style = ProgressBarStyle.Marquee;

            //Cration et lancement du thread
            if (th_Seeker != null && !th_Seeker.IsAlive)
            {
                ThreadDoctor th = new ThreadDoctor(tb_Nom.Text, tb_Prenom.Text, rb_Medic.Checked,
                 rb_Homeopath.Checked, this);
                th_Seeker = new Thread(new ThreadStart(th.ProcessOnName));
                th_Seeker.Name = "DataBase Thread";
                th_Seeker.Start();
            }
            else
            {
                if (th_Seeker != null)
                    th_Seeker.Abort();

                ThreadDoctor th = new ThreadDoctor(tb_Nom.Text, tb_Prenom.Text, rb_Medic.Checked,
                    rb_Homeopath.Checked, this);
                th_Seeker = new Thread(new ThreadStart(th.ProcessOnName));
                th_Seeker.Name = "DataBase Thread";
                th_Seeker.Start();
            }
        }
        #endregion

        #region Accesseur
        /// <summary>
        /// Mdecin selectionn
        /// </summary>
        public DoctorManager SelectedItem { get { return vDoctorManager; } }
        #endregion 
    }

    /// <summary>
    /// Classe du thread
    /// </summary>
    internal class ThreadDoctor
    {
        #region Variables
        /// <summary>
        /// Indique si on recherche un mdecin
        /// </summary>
        private bool vIsMedecin;

        /// <summary>
        /// Indique si on recherche un homopathe
        /// </summary>
        private bool vIsHomeopathe;

        /// <summary>
        /// Indique le nom du mdecin
        /// </summary>
        private string vNom;

        /// <summary>
        /// Indique le prnom du mdecin
        /// </summary>
        private string vPrenom;

        /// <summary>
        /// La frame que le delegate va travailler
        /// </summary>
        private fr_DoctorSeeker vDoctorSeeker;

        /// <summary>
        /// Delegate pour le traitement GUI inter threads
        /// </summary>
        /// <param name="_ds"></param>
        private delegate void UpdateGuiHandler(DataSet _ds);

        /// <summary>
        /// Mthode de tratement inter threads
        /// </summary>
        private UpdateGuiHandler UpdateGui;

        /// <summary>
        /// Manager SQL
        /// </summary>
        protected OleDbSql SqlManager = new OleDbSql(Options.GetInstance().Path);
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_FamilyName">Nom de famille du mdecin</param>
        /// <param name="_Name">Prnom du mdecin</param>
        /// <param name="_IsDoctor">True si le mdecin est un mdecin traitant</param>
        /// <param name="_IsHomeopath">True si le mdecin est un homopathe</param>
        /// <param name="_frame">la frame sur laquelle on fera le traitement graphique</param>
        public ThreadDoctor(string _FamilyName, string _Name,
            bool _IsDoctor, bool _IsHomeopath, fr_DoctorSeeker _frame)
        {
            vNom = _FamilyName;
            vPrenom = _Name;
            vIsMedecin = _IsDoctor;
            vIsHomeopathe = _IsHomeopath;
            vDoctorSeeker = _frame;
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Fait une recherche de mdecin sur le nom, prnom, spcialit
        /// </summary>
        public void ProcessOnName()
        {
            string Nom = vNom + "%";
            string Prenom = vPrenom + "%";

            SqlManager.PrepareProcedure("SELECT_Medecin");
            SqlManager.Parameters.Add("[_Name]", OleDbType.Variant).Value = Nom;
            SqlManager.Parameters.Add("[_Surname]", OleDbType.Variant).Value = Prenom;
            SqlManager.Parameters.Add("[_Med]", OleDbType.Boolean).Value = this.vIsMedecin;
            SqlManager.Parameters.Add("[_Homeo]", OleDbType.Boolean).Value = this.vIsHomeopathe;

            try
            {
                DataSet ds = new DataSet();
                SqlManager.ExecuteSqlProcedure(ref ds);

                UpdateGui = new UpdateGuiHandler(this.FillDataGridView);
                try { vDoctorSeeker.Invoke(UpdateGui, ds); }
                catch (InvalidOperationException ex)
                { Log.GetInstance().Write(ex.Message, "ThreadHandle.ProcessOnName()", LogType.Erreur); }
            }
            catch (OleDbException ex)
            {
                MessageBox.Show(ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        /// <summary>
        /// Mthode de traitement de la GUI
        /// </summary>
        /// <param name="_ds">Dataset contenant les informations pour le remplissage du DataGridView</param>
        private void FillDataGridView(DataSet _ds)
        {
            try
            {
                this.vDoctorSeeker.dgv_Results.DataSource = _ds.Tables[0];

                for (int i = 0; i < this.vDoctorSeeker.dgv_Results.Columns.Count; i++)
                    this.vDoctorSeeker.dgv_Results.Columns[i].Visible = false;

                this.vDoctorSeeker.dgv_Results.Columns["Nom"].Visible = true;
                this.vDoctorSeeker.dgv_Results.Columns["Nom"].HeaderText = "Nom";

                this.vDoctorSeeker.dgv_Results.Columns["Prenom"].Visible = true;
                this.vDoctorSeeker.dgv_Results.Columns["Prenom"].HeaderText = "Prnom";

                this.vDoctorSeeker.dgv_Results.Columns["Homeopathe"].Visible = true;
                this.vDoctorSeeker.dgv_Results.Columns["Homeopathe"].HeaderText = "Homopathe";

                this.vDoctorSeeker.dgv_Results.Columns["MedecinTraitant"].Visible = true;
                this.vDoctorSeeker.dgv_Results.Columns["MedecinTraitant"].HeaderText = "Mdecin traitant";

                this.vDoctorSeeker.tsPB_ProgressBar.Style = ProgressBarStyle.Blocks;
            }
            catch (Exception ex)
            {
                Log.GetInstance().Write(ex.Message, "FillDataGridView", LogType.Erreur);
            }
        }
        #endregion
    }

    /// <summary>
    /// Arguments d'un vnement de selection de patient
    /// </summary>
    public class DoctorEventArgs : EventArgs
    {
        #region Accesseurs
        /// <summary>
        /// Information sur un mdecin
        /// </summary>
        private DoctorManager vDoctorManager;
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_DoctorManager">Informations sur le mdecin</param>
        public DoctorEventArgs(DoctorManager _DoctorManager) { vDoctorManager = _DoctorManager; }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise un DoctorManager contenant les informations sur un mdecin
        /// </summary>
        public DoctorManager DoctorManager
        {
            get { return vDoctorManager; }
            set { vDoctorManager = value; }
        }
        #endregion
    }
}

