using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.GUI.Seekers.Root;
using PhoenixDLL.Class.Managers;
using PhoenixDLL.GUI.Managers;
using Utils.DataBase;
using PhoenixDLL.Class;

namespace PhoenixDLL.GUI.Seekers
{
    /// <summary>
    /// Chercheur de type de mdicament
    /// </summary>
    public partial class fr_DrugsTypeSeeker : fr_RootComboBoxSeeker
    {
        #region Variables
        /// <summary>
        /// Gestionnaire de type de mdicaments
        /// </summary>
        private DrugsTypeManager vDrugsTypeManager = new DrugsTypeManager();

        /// <summary>
        /// Gestionnaire de SQL
        /// </summary>
        OleDbSql SqlManager = new OleDbSql(Options.GetInstance().Path);
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_DrugsTypeSeeker()
        {
            InitializeComponent();
            base.Text = "Gestion des types de mdicaments";
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Effectue un ajout de type de mdicament
        /// </summary>
        protected override void PerformAdd()
        {
            fr_DrugsTypeManager fr = new fr_DrugsTypeManager();
            fr.Use = Use.Add;
            fr.Manager = new DrugsTypeManager();
            fr.ShowDialog();
            base.PerformAdd();
        }
        /// <summary>
        /// Effectue une selection de type de mdicament
        /// </summary>
        protected override void PerformSelect()
        {
            DataRowView dr = (DataRowView)cb_Reput.SelectedItem;
            vDrugsTypeManager = new DrugsTypeManager();
            vDrugsTypeManager.ID = (int)dr["id_type"];
            vDrugsTypeManager.Type = (string)dr["Type"];
            vDrugsTypeManager.Remark = (string)dr["Rmq"];
            base.PerformSelect();
        }
        /// <summary>
        /// Remplissage de la ComboBox avec les types de mdicaments
        /// </summary>
        protected override void PerformFillComboBox()
        {            
            DataSet ds = new DataSet();
            SqlManager.ExecuteSql("SELECT * FROM Type_Medicament", ref ds);
            cb_Reput.DataSource = ds.Tables[0];
            cb_Reput.DisplayMember = "Type";
            base.PerformFillComboBox();
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne le type de mdicament slectionn
        /// </summary>
        public DrugsTypeManager SelectedItem { get { return vDrugsTypeManager; } }
        #endregion
    }
}

