using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class.Managers;
using Utils.DataBase;
using PhoenixDLL.Class;
using PhoenixDLL.GUI.Managers;
using PhoenixDLL.GUI.Seekers.Root;

namespace PhoenixDLL.GUI.Seekers
{
    /// <summary>
    /// Rechercheur de mutuelle
    /// </summary>
    public partial class fr_MutuelleSeeker : fr_RootComboBoxSeeker
    {
        #region Variables
        /// <summary>
        /// Gestionnaire de mutuelle
        /// </summary>
        private MutuelleManager vMutuelleManager = new MutuelleManager();

        /// <summary>
        /// Gestionnaire SQL
        /// </summary>
        private OleDbSql SqlManager = new OleDbSql(Options.GetInstance().Path);
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_MutuelleSeeker()
        {
            InitializeComponent();
            base.Text = "Gestion des mutuelles";
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Excute un ajour de mutuelle
        /// </summary>
        protected override void PerformAdd()
        {
            fr_MutuelleManager fr = new fr_MutuelleManager();

            fr.Use = Use.Add;
            fr.Manager = vMutuelleManager;

            fr.ShowDialog();
            base.PerformAdd();
        }

        /// <summary>
        /// Exccute une slection d'une mutuelle
        /// </summary>
        protected override void PerformSelect()
        {
            DataRowView dr = (DataRowView)cb_Reput.SelectedItem;
            vMutuelleManager = new MutuelleManager();
            vMutuelleManager.ID = (int)dr["id_Honoraire"];
            vMutuelleManager.Type = (string)dr["Type"];            
            base.PerformSelect();
        }

        /// <summary>
        /// Fait un remplissage de la ComboBox
        /// </summary>
        protected override void PerformFillComboBox()
        {
            SqlManager.PrepareProcedure("SELECT_AllHonoraire");
            DataSet ds = new DataSet();
            SqlManager.ExecuteSqlProcedure(ref ds);            

            cb_Reput.DataSource = ds.Tables[0];
            cb_Reput.DisplayMember = "Type";
            
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne la mutuelle slectionne
        /// </summary>
        public MutuelleManager SelectedItem { get { return vMutuelleManager; } }
        #endregion
    }
}

