using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class.Managers;
using Utils.DataBase;
using System.Threading;
using Utils.Log;
using PhoenixDLL.Class;
using System.Data.OleDb;
using Utils.Misc;
using PhoenixDLL.GUI.Seekers.Root;
using PhoenixDLL.GUI.Managers;

namespace PhoenixDLL.GUI.Seekers
{
    /// <summary>
    /// Chercheur de patient
    /// </summary>
    public partial class fr_PatientSeeker : fr_RootSeeker
    {
        #region Variables
        /// <summary>
        /// Manager de patient
        /// </summary>
        private PatientManager vPatientManager = new PatientManager();
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_PatientSeeker()
        {
            InitializeComponent();
        }
        #endregion

        #region Event
        /// <summary>
        /// Changement de texte dans les TextBoxes
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_TextChanged(object sender, EventArgs e) { RefreshDGV(); }
        /// <summary>
        /// Chargement de la fentre
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_LoadFrame(object sender, EventArgs e)
        {
            tb_Name.Focus();
        }
        #endregion

        #region Methodes
        /// <summary>
        /// Execution d'un double clique
        /// </summary>
        protected override void ExecuteDoubleClick()
        {
            base.ExecuteDoubleClick();

            if (dgv_Results.SelectedRows.Count != 0)
            {
                base.DialogResult = DialogResult.OK;

                #region Remplissage d'un PatientManager
                try
                {
                    vPatientManager.IDPatient = (int)dgv_Results.SelectedRows[0].Cells["Id_Patient"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Adresse"].Value.Equals(DBNull.Value))
                        vPatientManager.Address = (string)dgv_Results.SelectedRows[0].Cells["Adresse"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Ville"].Value.Equals(DBNull.Value))
                        vPatientManager.City = (string)dgv_Results.SelectedRows[0].Cells["Ville"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["DateNaissance"].Value.Equals(DBNull.Value))
                        vPatientManager.DateOfBirth = (DateTime)dgv_Results.SelectedRows[0].Cells["DateNaissance"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Nom"].Value.Equals(DBNull.Value))
                        vPatientManager.FamillyName = (string)dgv_Results.SelectedRows[0].Cells["Nom"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["ID_Homeopathe"].Value.Equals(DBNull.Value))
                    {
                        vPatientManager.Homeopathe.ID = (int)dgv_Results.SelectedRows[0].Cells["ID_Homeopathe"].Value;
                        vPatientManager.Homeopathe = vPatientManager.GetDoctor(vPatientManager.Homeopathe.ID);
                    }

                    if (!dgv_Results.SelectedRows[0].Cells["id_medecin"].Value.Equals(DBNull.Value))
                    {
                        vPatientManager.MedecinTraitant.ID = (int)dgv_Results.SelectedRows[0].Cells["id_medecin"].Value;
                        vPatientManager.MedecinTraitant = vPatientManager.GetDoctor(vPatientManager.MedecinTraitant.ID);
                    }

                    if (!dgv_Results.SelectedRows[0].Cells["id_Reputation"].Value.Equals(DBNull.Value))
                    {
                        vPatientManager.Reputation.ID = (int)dgv_Results.SelectedRows[0].Cells["id_Reputation"].Value;
                        vPatientManager.Reputation = vPatientManager.GetReputation(vPatientManager.Reputation.ID);
                    }

                    if (!dgv_Results.SelectedRows[0].Cells["Motif_1"].Value.Equals(DBNull.Value))
                        vPatientManager.Motif1 = (string)dgv_Results.SelectedRows[0].Cells["Motif_1"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Motif_2"].Value.Equals(DBNull.Value))
                        vPatientManager.Motif2 = (string)dgv_Results.SelectedRows[0].Cells["Motif_2"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Prenom"].Value.Equals(DBNull.Value))
                        vPatientManager.Surname = (string)dgv_Results.SelectedRows[0].Cells["Prenom"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Lieu_Naissance"].Value.Equals(DBNull.Value))
                        vPatientManager.PlaceOfBirth = (string)dgv_Results.SelectedRows[0].Cells["Lieu_Naissance"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Telephone_prive"].Value.Equals(DBNull.Value))
                        vPatientManager.PrivatePhone = (string)dgv_Results.SelectedRows[0].Cells["Telephone_prive"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Profession"].Value.Equals(DBNull.Value))
                        vPatientManager.Profession = (string)dgv_Results.SelectedRows[0].Cells["Profession"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Telephone_professionel"].Value.Equals(DBNull.Value))
                        vPatientManager.ProPhone = (string)dgv_Results.SelectedRows[0].Cells["Telephone_professionel"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Mail"].Value.Equals(DBNull.Value))
                        vPatientManager.Mail = (string)dgv_Results.SelectedRows[0].Cells["Mail"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Code_Postal"].Value.Equals(DBNull.Value))
                        vPatientManager.ZipCode = (string)dgv_Results.SelectedRows[0].Cells["Code_Postal"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["id_Honoraire"].Value.Equals(DBNull.Value))
                    {
                        vPatientManager.Mutuelle.ID = (int)dgv_Results.SelectedRows[0].Cells["id_Honoraire"].Value;
                        vPatientManager.Mutuelle = vPatientManager.GetHonoraire(vPatientManager.Mutuelle.ID);
                    }

                    if (dgv_Results.SelectedRows[0].Cells["Sexe"].Value.Equals(DBNull.Value))
                        vPatientManager.Sex = Sex.Femme; //Parce qu'elles sont plus nombreuse ;)

                    else if (((string)dgv_Results.SelectedRows[0].Cells["Sexe"].Value).ToLower() == "m")
                        vPatientManager.Sex = Sex.Homme;
                    else
                        vPatientManager.Sex = Sex.Femme;

                    if (!dgv_Results.SelectedRows[0].Cells["derniere_MAJ"].Value.Equals(DBNull.Value))
                        vPatientManager.LastUpdate = (DateTime)dgv_Results.SelectedRows[0].Cells["derniere_MAJ"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Honoraire"].Value.Equals(DBNull.Value))
                        vPatientManager.Honoraire = (int)dgv_Results.SelectedRows[0].Cells["Honoraire"].Value;

                    if (!dgv_Results.SelectedRows[0].Cells["Dette_Patient"].Value.Equals(DBNull.Value))
                    {
                        int vdebt = (int)dgv_Results.SelectedRows[0].Cells["Dette_Patient"].Value;
                        vPatientManager.UpdateDebt(vdebt);
                    }

                    if (!dgv_Results.SelectedRows[0].Cells["Prem_Consult"].Value.Equals(DBNull.Value))
                        vPatientManager.DateInscription = (DateTime)dgv_Results.SelectedRows[0].Cells["Prem_Consult"].Value;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Impossible de remplir les informations sur le patient.\r\n(" 
                        + ex.Message + ")", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    Log.Instance.Write(ex.Message, "fr_PatientSeeker.ExecuteDoubleClick()", LogType.Erreur);
                }
                #endregion
            }
        }
        /// <summary>
        /// Excute un ajout de patient
        /// </summary>
        protected override void ExecuteAdd()
        {
            fr_PatientManager fr = new fr_PatientManager();
            fr.Use = Use.Add;
            fr.Manager = new PatientManager();
            fr.Size = new Size(fr.Size.Width, 600);
            DialogResult dr = fr.ShowDialog();
            if (dr != DialogResult.OK) return;
            RefreshDGV();
        }
        /// <summary>
        /// Delete the patient
        /// </summary>
        protected override void ExecuteDel()
        {
            fr_PatientManager fr = new fr_PatientManager();
            fr.Use = Use.Delete;
            fr.Manager = new PatientManager();
            fr.Size = new Size(fr.Size.Width, 600);
            DialogResult dr = fr.ShowDialog();
            if (dr != DialogResult.OK) return;
            RefreshDGV();
        }
        /// <summary>
        /// Refreshes the DataGridView
        /// </summary>
        protected override void RefreshDGV()
        {
            try
            {
                //if (IsTextChanged)
                {
                    tsPB_ProgressBar.Style = ProgressBarStyle.Marquee;

                    //Cration et lancement du thread
                    if (th_Seeker != null && !th_Seeker.IsAlive)
                    {
                        ThreadPatient th = new ThreadPatient(tb_Name.Text, tb_Surname.Text, this);
                        th_Seeker = new Thread(new ThreadStart(th.ProcessOnName));
                        th_Seeker.Name = "DataBase Thread";
                        th_Seeker.Start();
                    }
                    else
                    {
                        if (th_Seeker != null)
                            th_Seeker.Abort();

                        ThreadPatient th = new ThreadPatient(tb_Name.Text, tb_Surname.Text, this);
                        th_Seeker = new Thread(new ThreadStart(th.ProcessOnName));
                        th_Seeker.Name = "DataBase Thread";
                        th_Seeker.Start();
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Attention", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                Log.GetInstance().Write(ex.Message, "fr_PatientSeeker.TextChanged()", LogType.Erreur);

                if (th_Seeker != null)
                    th_Seeker.Abort();
            }
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne le patient selectionn
        /// </summary>
        public PatientManager SelectedItem { get { return vPatientManager; } }
        /// <summary>
        /// Retourne les informations sur les diffrentes fiches
        /// </summary>
        public CardsInfo CardsInfo
        {
            get
            {
                CardsInfo Card = new CardsInfo(); ;
                if (vPatientManager.IDPatient > 0)
                {
                    if (!DBNull.Value.Equals(dgv_Results.SelectedRows[0].Cells["Biodynamics"].Value))
                        Card.Biodynamics = (string)dgv_Results.SelectedRows[0].Cells["Biodynamics"].Value;
                    else
                        Card.Biodynamics = "";
                    if (!DBNull.Value.Equals(dgv_Results.SelectedRows[0].Cells["FicheMedicale"].Value))
                        Card.Cards = (string)dgv_Results.SelectedRows[0].Cells["FicheMedicale"].Value;
                    else
                        Card.Cards = "";

                    if (!DBNull.Value.Equals(dgv_Results.SelectedRows[0].Cells["HE"].Value))
                        Card.HE = (string)dgv_Results.SelectedRows[0].Cells["HE"].Value;
                    else
                        Card.HE = "";


                    Card.IsFilled = true;

                    if (!DBNull.Value.Equals(dgv_Results.SelectedRows[0].Cells["Kinergetique"].Value))
                        Card.Kinergetique = (string)dgv_Results.SelectedRows[0].Cells["Kinergetique"].Value;
                    else
                        Card.Kinergetique = "";
                    if (!DBNull.Value.Equals(dgv_Results.SelectedRows[0].Cells["FICHE_SUPPL_1"].Value))
                        Card.Tab1 = (string)dgv_Results.SelectedRows[0].Cells["FICHE_SUPPL_1"].Value;
                    else
                        Card.Tab1 = "";

                    if (!DBNull.Value.Equals(dgv_Results.SelectedRows[0].Cells["FICHE_SUPPL_2"].Value))
                        Card.Tab2 = (string)dgv_Results.SelectedRows[0].Cells["FICHE_SUPPL_2"].Value;
                    else
                        Card.Tab2 = "";
                    if (!DBNull.Value.Equals(dgv_Results.SelectedRows[0].Cells["FICHE_SUPPL_3"].Value))
                        Card.Tab3 = (string)dgv_Results.SelectedRows[0].Cells["FICHE_SUPPL_3"].Value;
                    else
                        Card.Tab3 = "";
                    if (!DBNull.Value.Equals(dgv_Results.SelectedRows[0].Cells["FICHE_SUPPL_4"].Value))
                        Card.Tab4 = (string)dgv_Results.SelectedRows[0].Cells["FICHE_SUPPL_4"].Value;
                    else
                        Card.Tab4 = "";
                    return Card;
                }
                else
                {
                    Card.IsFilled = false;
                    return Card;
                }
            }
        }
        #endregion
    }

    /// <summary>
    /// Classe du thread
    /// </summary>
    internal class ThreadPatient
    {
        #region Variables
        /// <summary>
        /// Identifiant du patient
        /// </summary>
        protected int vID;

        /// <summary>
        /// Nom du patient
        /// </summary>
        protected string vNom;

        /// <summary>
        /// Prnom du patient
        /// </summary>
        protected string vPrenom;

        /// <summary>
        /// Handler de ma mise  jour de la DataGridView
        /// </summary>
        /// <param name="_ds">DataSet contenant les informations  afficher</param>
        protected delegate void UpdateGuiHandler(DataSet _ds);

        /// <summary>
        /// Handler de mise  jour
        /// </summary>
        protected UpdateGuiHandler UpdateGui;

        /// <summary>
        /// Rference sur la fentre pour les traitement de la GUI
        /// </summary>
        protected fr_PatientSeeker vFrame;

        /// <summary>
        /// Gestionnaire de SQL
        /// </summary>
        protected OleDbSql SqlManager = new OleDbSql(Options.GetInstance().Path);
        #endregion

        #region Constructeurs
        /// <summary>
        /// Constructeur par dfaut
        /// </summary>
        public ThreadPatient() { }

        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_ID">Identifiant du patient  trouver</param>
        ///<param name="_frame">Fentre dans laquelle se font les traitements GUI</param>        
        public ThreadPatient(int _ID, fr_PatientSeeker _frame)
        {
            vID = _ID;
            vFrame = _frame;
            vFrame.tsPB_ProgressBar = _frame.tsPB_ProgressBar;
            vFrame.dgv_Results = _frame.dgv_Results;
        }

        /// <summary>
        /// Constructeur
        /// </summary>
        /// <param name="_Nom">Nom (ou partie) du patient</param>
        /// <param name="_Prenom">Prnom (ou partie) du patient</param>
        ///<param name="_frame">Fentre dans laquelle se font les traitements GUI</param>        
        public ThreadPatient(string _Nom, string _Prenom, fr_PatientSeeker _frame)
        {
            vNom = _Nom;
            vPrenom = _Prenom;
            vFrame = _frame;
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Recherche d'un patient sur son nom et prnom
        /// </summary>
        public void ProcessOnName()
        {
            SqlManager.PrepareProcedure("SELECT_Patient");
            SqlManager.Parameters.Add("[_Nom]", OleDbType.VarChar).Value = vNom + "%";
            SqlManager.Parameters.Add("[_Prenom]", OleDbType.VarChar).Value = vPrenom + "%";

            try
            {
                DataSet ds = new DataSet();
                SqlManager.ExecuteSqlProcedure(ref ds);


                UpdateGui = new UpdateGuiHandler(this.FillDataGridView);
                try { vFrame.dgv_Results.Invoke(UpdateGui, ds); }
                catch (InvalidOperationException ex)
                { Log.GetInstance().Write(ex.Message, "ThreadHandle.ProcessOnName()", LogType.Erreur); }
            }
            catch (OleDbException ex)
            {
                MessageBox.Show(ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        /// <summary>
        /// Fait une recherche de patient sur son Identifiant
        /// </summary>
        public void ProcessOnID()
        {
            SqlManager.PrepareProcedure("SELECT_PatientOnID");
            SqlManager.Parameters.Add("[_ID]", OleDbType.Integer).Value = vID;
            DataSet ds = new DataSet();
            SqlManager.ExecuteSqlProcedure(ref ds);

            UpdateGui = new UpdateGuiHandler(this.FillDataGridView);
            try { vFrame.dgv_Results.Invoke(UpdateGui, ds); }
            catch (InvalidOperationException ex)
            { Log.GetInstance().Write(ex.Message, "ThreadHandle.ProcessOnName()", LogType.Erreur); }
        }

        /// <summary>
        /// Mthode de traitement du DataGridView
        /// </summary>
        /// <param name="_ds">DataSet qui doit tre DataSource du DataGridView</param>
        private void FillDataGridView(DataSet _ds)
        {
            #region Si les TextBoxes sont vides => c'est une demande de modification
            if (vFrame.tb_Name.Text == "" && vFrame.tb_Surname.Text == "" && _ds.Tables[0].Rows.Count == 1)
            {
                vFrame.tb_Name.Text = (string)_ds.Tables[0].Rows[0]["Nom"];
                vFrame.tb_Surname.Text = (string)_ds.Tables[0].Rows[0]["Prenom"];
            }
            #endregion

            vFrame.dgv_Results.DataSource = _ds.Tables[0];

            for (int i = 0; i < vFrame.dgv_Results.Columns.Count; i++)
                vFrame.dgv_Results.Columns[i].Visible = false;

            vFrame.dgv_Results.Columns["Nom"].Visible = true;
            vFrame.dgv_Results.Columns["Nom"].HeaderText = "Nom";

            vFrame.dgv_Results.Columns["Prenom"].Visible = true;
            vFrame.dgv_Results.Columns["Prenom"].HeaderText = "Prnom";

            vFrame.dgv_Results.Columns["DateNaissance"].Visible = true;
            vFrame.dgv_Results.Columns["DateNaissance"].HeaderText = "Date de naissance";

            vFrame.tsPB_ProgressBar.Style = ProgressBarStyle.Blocks;
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise le nom du patient
        /// </summary>
        public string Nom
        {
            get { return vNom; }
            set { vNom = value; }
        }

        /// <summary>
        /// Retourne ou initialise le prnom tu patient
        /// </summary>
        public string Prenom
        {
            get { return vPrenom; }
            set { vPrenom = value; }
        }

        /// <summary>
        /// Retourne ou initialise l'identifiant du patient  trouver
        /// </summary>
        public int ID
        {
            get { return vID; }
            set { vID = value; }
        }

        /// <summary>
        /// Retourn ou initialise le DataGrigView dans lequel on fait les affichages
        /// </summary>
        public fr_PatientSeeker Frame
        {
            get { return vFrame; }
            protected set { vFrame = value; }
        }
        #endregion
    }

    /// <summary>
    /// Contient les informations sur les fiches
    /// </summary>
    public struct CardsInfo
    {
        /// <summary>
        /// Indique si la fiche est remplie
        /// </summary>
        public bool IsFilled;

        /// <summary>
        /// Fiche mdicale
        /// </summary>
        public string Cards;

        /// <summary>
        /// Fiche HE
        /// </summary>
        public string HE;

        /// <summary>
        /// Fiche Biodynamics
        /// </summary>
        public string Biodynamics;

        /// <summary>
        /// Fiche Kinergetique
        /// </summary>
        public string Kinergetique;

        /// <summary>
        /// Fiche supplmentaire 1
        /// </summary>
        public string Tab1;

        /// <summary>
        /// Fiche supplmentaire 2        
        /// </summary>
        public string Tab2;

        /// <summary>
        /// Fiche supplmentaire 3
        /// </summary>
        public string Tab3;

        /// <summary>
        /// Fiche supplmentaire 4
        /// </summary>
        public string Tab4;
    }
}

