using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class.Managers;
using PhoenixDLL.GUI.Managers;
using Utils.DataBase;
using PhoenixDLL.Class;
using PhoenixDLL.GUI.Seekers.Root;

namespace PhoenixDLL.GUI.Seekers
{
    /// <summary>
    /// Chercheur de rputations
    /// </summary>
    public partial class fr_ReputationSeeker : fr_RootComboBoxSeeker
    {
        #region Variables
        /// <summary>
        /// Gestionnaire de rputation
        /// </summary>
        private ReputationManager vReputationManager = new ReputationManager();

        /// <summary>
        /// Manager de SQL
        /// </summary>
        private OleDbSql SqlManager = new OleDbSql(Options.GetInstance().Path);
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_ReputationSeeker()
        {
            InitializeComponent();
            base.Text = "Gestion des rputations...";
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Fait un ajout de rputation
        /// </summary>
        protected override void PerformAdd()
        {
            fr_ReputationManager fr = new fr_ReputationManager();

            fr.Use = Use.Add;
            fr.Manager = vReputationManager;

            fr.ShowDialog();


            SqlManager.PrepareProcedure("SELECT_AllReputation");
            DataSet ds = new DataSet();
            SqlManager.ExecuteSqlProcedure(ref ds);                        

            cb_Reput.DataSource = ds.Tables[0];
            cb_Reput.DisplayMember = "Label";

            base.PerformAdd();
        }

        /// <summary>
        /// Excute une selection de rputation
        /// </summary>
        protected override void PerformSelect()
        {
            DataRowView dr = (DataRowView)cb_Reput.SelectedItem;
            vReputationManager = new ReputationManager();
            vReputationManager.ID = (int)dr["id_Reputation"];
            vReputationManager.Label = (string)dr["Label"];
            base.PerformSelect();
        }

        /// <summary>
        /// Fait un remplissage de la ComboBox
        /// </summary>
        protected override void PerformFillComboBox()
        {
            SqlManager.PrepareProcedure("SELECT_AllReputation");
            DataSet ds = new DataSet();
            SqlManager.ExecuteSqlProcedure(ref ds);

            cb_Reput.DataSource = ds.Tables[0];
            cb_Reput.DisplayMember = "Label";

            base.PerformFillComboBox();
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Renvois le Manager de rputation selectionn.
        /// </summary>
        public ReputationManager SelectedItem { get { return vReputationManager; } }
        #endregion
    }
}

