using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration.Install;
using System.Collections;
using System.ComponentModel;
using Microsoft.Win32;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using Utils.Misc;

namespace PhoenixUninstaller.Class
{
    /// <summary>
    /// Description rsume de DemoInstaller.
    /// </summary>
    [RunInstaller(true)]
    public class InstallClass : Installer
    {
        /// <summary>
        /// Fait la dsinstallation
        /// </summary>
        /// <param name="savedState"></param>
        public override void Uninstall(IDictionary savedState)
        {
            base.Uninstall(savedState);

            FinishRemove();
        }

        #region Mthodes
        /// <summary>
        /// Termine l'effacement de la base de registre
        /// </summary>
        private void FinishRemove()
        {
            string Path = "";

            #region Sauvegarde de la base de donnes
            string _Path = "";
            bool IsPAth = GetDBPath(ref _Path);
            if (IsPAth)
            {
                DialogResult dr = MessageBox.Show("Vous tes sur le point de dsinstaller Phoenix Suite. "
                    + "Voulez-vous sauvegarder la base de donnes. (RECOMMANDER) Si vous cliquez sur NON, la base de donnes"
                    + " sera dfinitivement perdue!", "Attention",
                       MessageBoxButtons.YesNo, MessageBoxIcon.Asterisk);

                if (dr == DialogResult.Yes)
                {
                    #region SaveFileDialog setup
                    SaveFileDialog sfd = new SaveFileDialog();
                    sfd.Filter = @"""Base de donnes"" (*.mdb)| ""Tous les fichiers"" (*.*)";
                    DateTime dt = DateTime.Today;
                    sfd.FileName = "" + dt.Year + "-" + dt.Month + "-" + dt.Day + "-" + "GestionPatient.mdb";
                    dr = sfd.ShowDialog();
                    if (dr != DialogResult.OK) return;
                    #endregion

                    #region Traitement du nom du fichier
                    string FileName = sfd.FileName;
                    if (!FileName.EndsWith(".mdb")) FileName += ".mdb";
                    #endregion

                    #region Copie de la BD
                    FileInfo fi = new FileInfo(_Path);
                    fi.CopyTo(FileName, true);
                    #endregion
                }
            }
            #endregion

            #region Effacement des derniers fichiers
            RegistryKey CUKey = Registry.CurrentUser;
            RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\", true);

            if (key != null)
            {
                try
                {
                    Path = (string)key.GetValue("Path");
                    //MessageBox.Show("Del= \"" + Path + "\"");
                    Directory.Delete(Path, true);
                }
                catch (DirectoryNotFoundException)
                { MessageBox.Show("Phoenix est dj dsinstall", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                catch (UnauthorizedAccessException) { }

            }
            #endregion

            #region Effacement de la base de registre
            RegistryKey _CUKey = Registry.CurrentUser;
            RegistryKey _key = _CUKey.OpenSubKey(@"Software\\", true);

            if (_key != null)
            {
                try { _key.DeleteSubKeyTree("Phoenix"); }
                catch (ArgumentException) { /*La clef n'existe pas ;)*/}
                catch (Exception ex)
                {
                    MessageBox.Show("Une erreur est intervenue:\r\n" + ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

            }
            #endregion
        }     
        /// <summary>
        /// Retourne le path du fichier d'option
        /// </summary>
        /// <returns></returns>
        private static bool GetDBPath(ref string Path)
        {
            try
            {
                string RegistryPath = @"Software\Phoenix\";
                RegistryKey CUkey = Registry.CurrentUser;
                RegistryKey key = CUkey.OpenSubKey(RegistryPath, true);

                if (key != null)
                {
                    Path = (string)key.GetValue("DataBase");
                    return true;
                }
                else
                {
                    Path = (string)key.GetValue("Path") + @"\GestionPatient.mdb";
                    return true;
                }
            }
            catch (Exception) { return false; }
        }
        #endregion
    }
}
