using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using System.IO;
using System.Diagnostics;

namespace PhoenixUninstaller.GUI
{
    /// <summary>
    /// Dsinstalleur
    /// </summary>
    public partial class fr_Main : Form
    {
        #region Constructeurs
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_Main()
        {
            InitializeComponent();
        }
        #endregion

        #region Events
        /// <summary>
        /// Chargement de la fentre
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_Load(object sender, EventArgs e)
        {
            RegistryKey CUKey = Registry.CurrentUser;
            RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\", true);

            if (key != null)
            {
                foreach (string s in key.GetSubKeyNames())
                {
                    switch (s)
                    {
                        case "Cala":
                            cb_Cala.Enabled = true;
                            break;
                        case "Pata":
                            cb_Pata.Enabled = true;
                            break;
                        case "Poto":
                            cb_Poto.Enabled = true;
                            break;
                        case "Paga":
                            cb_Paga.Enabled = true;
                            break;
                        case "Stata":
                            cb_Stata.Enabled = true;
                            break;
                        case "Phoenix":
                            cb_PhoenixSuite.Enabled = true;
                            break;
                    }
                }
            }
        }

        /// <summary>
        /// Demande de dsinstallation
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_Process(object sender, EventArgs e)
        {
            #region PhoenixSuite
            if (cb_PhoenixSuite.Checked)
            {
                RegistryKey CUKey = Registry.CurrentUser;
                RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\Phoenix\", false);

                if (key == null)
                {
                    MessageBox.Show("Les informations d'installation de Phoenix sont corrompues",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    this.Close();
                }
                else
                {
                    try
                    {
                        Process[] p = Process.GetProcessesByName("PhoenixCommander.exe");
                        foreach (Process ps in p)
                            ps.Kill();
                        string Path = (string)key.GetValue("Path");
                        Directory.Delete(Path, true);
                        key = CUKey.OpenSubKey(@"Software\Phoenix\", true);
                        key.DeleteSubKey("Phoenix");
                        cb_PhoenixSuite.Enabled = false;
                        FinishRemove();

                    }
                    catch (DirectoryNotFoundException)
                    { MessageBox.Show("Phoenix est dj dsinstall", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                    catch (UnauthorizedAccessException ex)
                    { MessageBox.Show(ex.Message, "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }

                }
            }
            #endregion

            #region Cala
            if (cb_Cala.Checked)
            {
                RegistryKey CUKey = Registry.CurrentUser;
                RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\Cala\", false);

                if (key == null)
                {
                    MessageBox.Show("Les informations d'installation de Cala sont corrompues",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    this.Close();
                }
                else
                {
                    try
                    {
                        Process[] p = Process.GetProcessesByName("PhoenixAgenda.exe");
                        foreach (Process ps in p)
                            ps.Kill();
                        string Path = (string)key.GetValue("Path");
                        Directory.Delete(Path, true);
                        key = CUKey.OpenSubKey(@"Software\Phoenix\", true);
                        key.DeleteSubKey("Cala");
                        cb_Cala.Enabled = false;
                        FinishRemove();

                    }
                    catch (DirectoryNotFoundException)
                    { MessageBox.Show("Cala est dj dsinstall", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                    catch (UnauthorizedAccessException ex)
                    { MessageBox.Show(ex.Message, "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }

                }
            }
            #endregion

            #region Paga
            if (cb_Paga.Checked)
            {
                RegistryKey CUKey = Registry.CurrentUser;
                RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\Paga\", false);

                if (key == null)
                {
                    MessageBox.Show("Les informations d'installation de Paga sont corrompues",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    this.Close();
                }
                else
                {
                    try
                    {
                        string Path = (string)key.GetValue("Path");
                        Directory.Delete(Path, true);
                        key = CUKey.OpenSubKey(@"Software\Phoenix\", true);
                        key.DeleteSubKey("Paga");
                        cb_Paga.Enabled = false;
                        FinishRemove();
                    }
                    catch (DirectoryNotFoundException)
                    { MessageBox.Show("Cala est dj dsinstall", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                    catch (UnauthorizedAccessException ex)
                    { MessageBox.Show(ex.Message, "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }

                }

            }
            #endregion

            #region Pata
            if (cb_Pata.Checked)
            {
                RegistryKey CUKey = Registry.CurrentUser;
                RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\Pata\", false);

                if (key == null)
                {
                    MessageBox.Show("Les informations d'installation de Pata sont corrompues",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    this.Close();
                }
                else
                {
                    try
                    {
                        string Path = (string)key.GetValue("Path");
                        Directory.Delete(Path, true);
                        key = CUKey.OpenSubKey(@"Software\Phoenix\", true);
                        key.DeleteSubKey("Pata");
                        cb_Pata.Enabled = false;
                        FinishRemove();
                    }
                    catch (DirectoryNotFoundException)
                    { MessageBox.Show("Cala est dj dsinstall", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                    catch (UnauthorizedAccessException ex)
                    { MessageBox.Show(ex.Message, "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }

                }

            }
            #endregion

            #region Poto
            if (cb_Poto.Checked)
            {
                RegistryKey CUKey = Registry.CurrentUser;
                RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\Poto\", false);

                if (key == null)
                {
                    MessageBox.Show("Les informations d'installation de Pata sont corrompues",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    this.Close();
                }
                else
                {
                    try
                    {
                        string Path = (string)key.GetValue("Path");
                        Directory.Delete(Path, true);
                        key = CUKey.OpenSubKey(@"Software\Phoenix\", true);
                        key.DeleteSubKey("Poto");
                        cb_Poto.Enabled = false;
                        FinishRemove();
                    }
                    catch (DirectoryNotFoundException)
                    { MessageBox.Show("Cala est dj dsinstall", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                    catch (UnauthorizedAccessException ex)
                    { MessageBox.Show(ex.Message, "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }

                }

            }
            #endregion

            #region Stata
            if (cb_Stata.Checked)
            {
                RegistryKey CUKey = Registry.CurrentUser;
                RegistryKey key = CUKey.OpenSubKey(@"Software\Phoenix\Stata\", false);

                if (key == null)
                {
                    MessageBox.Show("Les informations d'installation de Pata sont corrompues",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    this.Close();
                }
                else
                {
                    try
                    {
                        string Path = (string)key.GetValue("Path");
                        Directory.Delete(Path, true);
                        key = CUKey.OpenSubKey(@"Software\Phoenix\", true);
                        key.DeleteSubKey("Stata");
                        cb_Stata.Enabled = false;
                        FinishRemove();
                    }
                    catch (DirectoryNotFoundException)
                    { MessageBox.Show("Cala est dj dsinstall", "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                    catch (UnauthorizedAccessException ex)
                    { MessageBox.Show(ex.Message, "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk); }
                }
            }
            #endregion
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Termine l'effacement de la base de registre
        /// </summary>
        private void FinishRemove()
        {
            #region Effacement terminal
            RegistryKey _CUKey = Registry.CurrentUser;
            RegistryKey _key = _CUKey.OpenSubKey(@"Software\\", true);

            if (_key != null)
            {
                try { _key.DeleteSubKeyTree("Phoenix"); }
                catch (ArgumentException) { /*La clef n'existe pas ;)*/}
                catch (Exception ex)
                {
                    MessageBox.Show("Une erreur est intervenue:\r\n" + ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

            }
            #endregion
        }
        #endregion
    }
}