using System;
using System.Collections.Generic;
using System.Text;

namespace Utils.ImageProcessing.Exceptions
{
    #region Exceptions
    /// <summary>
    /// Root exception for an image processing error
    /// </summary>
    public class ImageProcessingException : Exception
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public ImageProcessingException() : base("An error occured during the image processing...") { }
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="_Message">Error message to display</param>
        public ImageProcessingException(string _Message) : base(_Message) { }

    }
    /// <summary>
    /// Exception if an image is already locked for processing
    /// </summary>
    public class LockedBitmapException : ImageProcessingException
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public LockedBitmapException() : base("The image is already in use by another process...") { }
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="_Message">Error message to display</param>
        public LockedBitmapException(string _Message) : base(_Message) { }

    }

    /// <summary>
    /// Occured when an image processing attemped another imge format
    /// </summary>
    public class FormatBitmapException : ImageProcessingException
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public FormatBitmapException() : base("The processing attemped another image format") { }
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="_Message">Error message to display</param>
        public FormatBitmapException(string _Message) : base(_Message) { }
    }
    #endregion
}
