using System;
using System.Collections.Generic;
using System.Text;
using System.Globalization;

namespace Utils.Misc
{
    /// <summary>
    /// Classe statique pour le traitement des mois
    /// </summary>
    public static class Month
    {
        private static Calendar cal = new GregorianCalendar();

        /// <summary>
        /// Retourne le nombre de jour dans le mois de l'anne donne
        /// </summary>
        /// <param name="_Year">Anne du mois</param>
        /// <param name="_Month">Mois dont il faut compter le nombre de jour</param>
        /// <returns>Le nombre de jour</returns>
        public static int GetDaysInMonth(int _Year, int _Month)
        {
            return cal.GetDaysInMonth(_Year, _Month);
        }
    }

    /// <summary>
    /// Nom des mois en franais
    /// </summary>
    public static class FrenchMonth
    {
        #region Mois de l'anne
        /// <summary>
        /// January
        /// </summary>
        public static string January = "Janvier";
        /// <summary>
        /// February
        /// </summary>
        public static string February = "Fvrier";
        /// <summary>
        /// March
        /// </summary>
        public static string March = "Mars";
        /// <summary>
        /// April
        /// </summary>
        public static string April = "Avril";
        /// <summary>
        /// May
        /// </summary>
        public static string May = "Mai";
        /// <summary>
        /// June
        /// </summary>
        public static string June = "Juin";
        /// <summary>
        /// July
        /// </summary>
        public static string July = "Juillet";
        /// <summary>
        /// August
        /// </summary>
        public static string August = "Aot";
        /// <summary>
        /// September
        /// </summary>
        public static string September = "Septembre";
        /// <summary>
        /// October
        /// </summary>
        public static string October = "Octobre";
        /// <summary>
        /// November
        /// </summary>
        public static string November = "Novembre";
        /// <summary>
        /// December
        /// </summary>
        public static string December = "Dcembre";
        #endregion

        /// <summary>
        /// Retourne le mois indiqu par son numro
        /// </summary>
        /// <param name="i">Numro du mois (Va de 1  12)</param>
        /// <returns>Le nom du mois</returns>
        public static string GetNameOf(int i)
        {

            switch (i)
            {
                case 1:
                    return January;                    
                case 2:
                    return February;                    
                case 3:
                    return March;                    
                case 4:
                    return April;                    
                case 5:
                    return May;                    
                case 6:
                    return June;                    
                case 7:
                    return July;                    
                case 8:
                    return August;                    
                case 9:
                    return September;                    
                case 10:
                    return October;                    
                case 11:
                    return November;                    
                case 12:
                    return December;                    
                default:
                    throw new Exception("Choisisez une nombre entre 1 et 12. Vous avez choisi: " + i);
            }
        }
    }
}
