using System;
using System.Collections.Generic;
using System.Text;
using System.Globalization;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;
using System.Net.Mail;
using System.Net;

namespace Utils.Misc
{
    /// <summary>
    /// Classe de gestion des chaines de caractres
    /// </summary>
    public class TextManager
    {
        /// <summary>
        /// Remplace les caractres accentus par leur lettres sans accents
        /// </summary>
        /// <param name="_value">Texte  modifier</param>
        /// <returns>Le texte sans accents</returns>
        public static string RemoveAccent(string _value)
        {
            _value = _value.Replace("", "e");
            _value = _value.Replace("", "e");
            _value = _value.Replace("", "e");
            _value = _value.Replace("", "e");

            _value = _value.Replace("", "u");
            _value = _value.Replace("", "u");

            _value = _value.Replace("", "o");
            _value = _value.Replace("", "o");

            _value = _value.Replace("", "y");

            _value = _value.Replace("", "a");
            _value = _value.Replace("", "a");
            _value = _value.Replace("", "a");

            _value = _value.Replace("", "i");
            _value = _value.Replace("", "i");

            _value = _value.Replace("", "c");
            _value = _value.Replace("", "n");

            return _value;
        }

        /// <summary>
        /// Remplace les caractres accentus par leur lettres sans accents
        /// </summary>
        /// <param name="_value">Texte  modifier</param>
        /// <param name="_IsCapital">A true, retourne le texte en majuscule sinon en minuscule</param>
        /// <returns>Le texte sans accents</returns>
        public static string RemoveAccent(string _value, bool _IsCapital)
        {
            if (_IsCapital)
                return RemoveAccent(_value).ToUpper();
            else
                return RemoveAccent(_value).ToLower();
        }

        /// <summary>
        /// Met le premier caractre en majuscule
        /// </summary>
        /// <param name="_value">Le texte dont le premier lettre doit tre en majuscule</param>
        /// <returns>Le texte avec le premier caractre en majuscule</returns>
        public static string FirstUpper(string _value)
        {
            string temp = _value.Substring(0, 1);
            return temp.ToUpper() + _value.Remove(0, 1);
        }

        /// <summary>
        /// Donne le nombre d'occurence de la sous-chaine dans la chane
        /// </summary>
        /// <param name="_Value">Chaine dans laquelle on compte les occurences de _SubString</param>
        /// <param name="_SubValue">Sous chaine dont il faut compter les occurences</param>
        /// <returns></returns>
        public static int CountIn(string _Value, string[] _SubValue)
        {
            if (_Value == null || _SubValue == null) return 0;
            string[] buf = _Value.Split(_SubValue, StringSplitOptions.None);
            return buf.Length;
        }
    }
}
